
'$use "ocx\\MSXML2.lib"
'added _CLSID_DOMDocument30.obj to xml.lib

' LPWSTR     -> wstring
' pXML       -> pointer to XML class (document or node)
' ppwszName  -> address of wstring pointer
' VariantVal -> pointer to VARIANT

class XML

	declare XML()
	declare _XML()
	'
	' initialization
	'
	declare Open(LPWSTR wszPath,opt BOOL fAsync=FALSE,opt BOOL externals=FALSE),BOOL
	declare InitNew(),BOOL
	declare AttachNode(comref pIXMLDOMNode),BOOL

	declare Save(LPWSTR wszPath),BOOL
	declare GetError(),LPWSTR
	'
	' browsing
	'
	declare GetFirstNode(opt pointer pXML=0),BOOL
	declare GetNextNode(pointer pXML),BOOL
	declare GetChildNodeCount(),int

	declare GetFirstAttribute(opt pointer ppwszName,pointer VariantVal),BOOL
	declare GetNextAttribute(pointer ppwszName,pointer VariantVal),BOOL
	declare GetAttributeCount(),int
	'
	' modifications
	'
	declare SetVersion(LPWSTR version)
	declare AppendChildNode(LPWSTR wszName,opt LPWSTR wszText,pointer pXML),BOOL
	declare AppendText(LPWSTR wszText),BOOL
	declare AppendComment(LPWSTR wszText, pointer pXML),BOOL
	declare AppendCDATA(LPWSTR wszText, pointer pXML),BOOL
	declare SetAttribute(LPWSTR wszName, LPWSTR value),BOOL
	declare SetAttributeEx(LPWSTR wszName, pointer VariantVal),BOOL
	declare RemoveAttribute(LPWSTR wszName),BOOL
	declare RemoveNode(pointer pXML),BOOL
	'
	' querying
	'
	declare GetAttribute(LPWSTR wszName,pointer VariantVal),BOOL
	declare HasChildNodes(),BOOL
	declare GetName(),LPWSTR
	declare GetText(),LPWSTR
	declare GetValue(pointer VariantVal),BOOL
	'
	' private
	'
	declare Cleanup()
	declare IsIXMLDOMDocument(),BOOL

	int m_xmlreserved[5]
/*	IXMLDOMDocument     m_doc[0]
	IXMLDOMNode         m_node
	IXMLDOMNodeList     m_childs
	BSTR                m_name
	BSTR                m_text
	IXMLDOMNamedNodeMap m_attrs*/
endclass


declare extern V_BSTR(VARIANT pv, LPWSTR str)

/*
 * how to use optional parameter in GetFirstNode
 *
 * XML node
 * x.GetFirstNode(NULL)
 * while (x.GetNextNode(&node))
 *    something()
 * endwhile
 *
 * if (x.GetFirstNode(&node))
 *   do
 *      something()
 *   until x.GetNextNode(&node) = FALSE
 * endif
*/

/*
 * how to use optional parameter in GetFirstAttribute
 *
 * POINTER pwszName : SETTYPE pwszName, WSTRING
 * VARIANT value
 * x.GetFirstAttribute(NULL, NULL)
 * while (x.GetNextAttribute(&pwszName, &value))
 *    something()
 *    VariantClear(&value)
 * endwhile
 *
 * if (x.GetFirstAttribute(&pwszName, &value))
 *   do
 *      something()
 *      VariantClear(&value)
 *   until x.GetNextAttribute(&pwszName, &value) = FALSE
 * endif
*/

